import React from 'react';
import PropTypes from 'prop-types';

declare class ValidatorComponent extends React.Component<any, any, any> {
    static getDerivedStateFromProps(nextProps: any, prevState: any): {
        value: any;
        validators: any;
        errorMessages: any;
    } | {
        value: any;
        validators?: undefined;
        errorMessages?: undefined;
    };
    constructor(props: any);
    constructor(props: any, context: any);
    state: {
        isValid: boolean;
        value: any;
        errorMessages: any;
        validators: any;
    };
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    componentDidUpdate(prevProps: any, prevState: any): void;
    componentWillUnmount(): void;
    getErrorMessage: () => any;
    instantValidate: boolean;
    invalid: any[];
    configure: () => void;
    debounceTime: any;
    validateDebounced: {
        (value?: any, includeRequired?: boolean | undefined, dryRun?: boolean | undefined): void;
        cancel: () => void;
    } | undefined;
    validate: (value: any, includeRequired?: boolean, dryRun?: boolean) => Promise<boolean>;
    isValid: () => boolean;
    makeInvalid: () => void;
    makeValid: () => void;
    renderComponent: (form: any) => any;
    form: any;
    render(): React.JSX.Element;
}
declare namespace ValidatorComponent {
    namespace propTypes {
        let errorMessages: PropTypes.Requireable<NonNullable<string | any[] | null | undefined>>;
        let validators: PropTypes.Requireable<any[]>;
        let value: PropTypes.Requireable<any>;
        let validatorListener: PropTypes.Requireable<(...args: any[]) => any>;
        let withRequiredValidator: PropTypes.Requireable<boolean>;
        let containerProps: PropTypes.Requireable<object>;
    }
    namespace defaultProps {
        let errorMessages_1: string;
        export { errorMessages_1 as errorMessages };
        let validators_1: never[];
        export { validators_1 as validators };
        export function validatorListener_1(): void;
        export { validatorListener_1 as validatorListener };
    }
}

declare class TextValidator extends ValidatorComponent {
    renderValidatorComponent(): React.JSX.Element;
}

declare class MuiSelect$1 extends ValidatorComponent {
    renderValidatorComponent(): React.JSX.Element;
}

declare class ValidatorForm extends React.Component<any, any, any> {
    static getValidator: (validator: any, value: any, includeRequired: any) => boolean;
    constructor(props: any);
    constructor(props: any, context: any);
    getFormHelpers: () => {
        form: {
            attachToForm: (component: any) => void;
            detachFromForm: (component: any) => void;
            instantValidate: any;
            debounceTime: any;
        };
    };
    instantValidate: any;
    debounceTime: any;
    childs: any[];
    errors: any[];
    attachToForm: (component: any) => void;
    detachFromForm: (component: any) => void;
    submit: (event: any) => void;
    walk: (children: any, dryRun: any) => Promise<any>;
    checkInput: (input: any, dryRun: any) => Promise<any>;
    validate: (input: any, includeRequired: any, dryRun: any) => Promise<any>;
    find: (collection: any, fn: any) => any;
    resetValidations: () => void;
    isFormValid: (dryRun?: boolean) => Promise<any>;
    render(): React.JSX.Element;
}
declare namespace ValidatorForm {
    function addValidationRule(name: any, callback: any): void;
    function getValidationRule(name: any): any;
    function hasValidationRule(name: any): any;
    function removeValidationRule(name: any): void;
    namespace propTypes {
        let onSubmit: PropTypes.Validator<(...args: any[]) => any>;
        let instantValidate: PropTypes.Requireable<boolean>;
        let children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        let onError: PropTypes.Requireable<(...args: any[]) => any>;
        let debounceTime: PropTypes.Requireable<number>;
    }
    namespace defaultProps {
        export function onError_1(): void;
        export { onError_1 as onError };
        let debounceTime_1: number;
        export { debounceTime_1 as debounceTime };
    }
}

declare const MuiTextField: typeof TextValidator;
declare const MuiSelect: typeof MuiSelect$1;
declare const MuiComponent: typeof ValidatorComponent;
declare const MuiForm: typeof ValidatorForm;

export { MuiComponent, MuiForm, MuiSelect, MuiTextField };
